OpenVDB: AssignExpression Struct Reference

OpenVDB 10.0.1

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
AssignExpression Struct Reference

AssignExpressions represents a similar object construction to a BinaryOperator. AssignExpressions can be chained together and are thus derived as Expressions rather than Statements. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for AssignExpression:

## Public Types
using | UniquePtr = std::unique_ptr< AssignExpression >
enum | NodeType { TreeNode , StatementListNode , BlockNode , ConditionalStatementNode , CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode , CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode , CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode , DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode , ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node , ValueFloatNode , ValueDoubleNode , ValueStrNode }
| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr< Node >

## Public Member Functions
| AssignExpression (Expression *lhs, Expression *rhs, const tokens::OperatorToken op=tokens::EQUALS)
| Construct a new AssignExpression with valid LHS and RHS expressions, transferring ownership of the expressions to the AssignExpression and updating parent data on the expressions.
| AssignExpression (const AssignExpression &other)
| Deep copy constructor for an AssignExpression, performing a deep copy on both held expressions, ensuring parent information is updated.
| ~AssignExpression () override=default
AssignExpression * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const Expression * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
size_t | children () const override final
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Expression * | child (const size_t i) const override final
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
bool | replacechild (const size_t i, Node *node) override final
| Virtual method that attempted to replace a child at a given index with a provided node type.
bool | isCompound () const
| Query whether or not this is a compound AssignExpression. Compound AssignExpressions are assignments which read and write to the LHS value. i.e. +=, -=, *= etc.
tokens::OperatorToken | operation () const
| Query the actual operational type of this AssignExpression. For simple (non-compound) AssignExpressions, tokens::EQUALS is returned.
const Expression * | lhs () const
| Access a const pointer to the AssignExpression LHS as an abstract expression.
const Expression * | rhs () const
| Access a const pointer to the AssignExpression RHS as an.
Name/Type
template<typename NodeT >
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Detailed Description

AssignExpressions represents a similar object construction to a BinaryOperator. AssignExpressions can be chained together and are thus derived as Expressions rather than Statements.

Note
  AssignExpressions can either be direct or compound assignments. The latter is represented by the last argument in the primary constructor which is expected to be a valid binary token.

## Member Typedef Documentation

## ◆ Ptr

using Ptr = std::shared_ptr<Node>
| inherited

## ◆ UniquePtr

using UniquePtr = std::unique_ptr<AssignExpression>

## Member Enumeration Documentation

## ◆ NodeType

enum NodeType
| inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## ◆ AssignExpression() [1/2]

AssignExpression | ( | Expression * | lhs,
|  | Expression * | rhs,
|  | const tokens::OperatorToken | op = `tokens::EQUALS`
| ) |  |
| inline

Construct a new AssignExpression with valid LHS and RHS expressions, transferring ownership of the expressions to the AssignExpression and updating parent data on the expressions.

Parameters

  lhs | The left hand side of the assign expression
  rhs | The right hand side of the assign expression
  op | The compound assignment token, if any

## ◆ AssignExpression() [2/2]

AssignExpression | ( | const AssignExpression & | other | ) |
| inline

Deep copy constructor for an AssignExpression, performing a deep copy on both held expressions, ensuring parent information is updated.

Parameters

  other | A const reference to another AssignExpression to deep copy

## ◆ ~AssignExpression()

~AssignExpression | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ basetype()

const Expression * basetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Node.

## ◆ child()

const Expression * child | ( | const size_t | i | ) | const
| inlinefinaloverridevirtual

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Implements Node.

## ◆ childidx()

int64_t childidx | ( |  | ) | const
| inlineinherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)

Returns
  The child index of this node

## ◆ children()

size_t children | ( |  | ) | const
| inlinefinaloverridevirtual

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Implements Node.

## ◆ copy()

AssignExpression * copy | ( |  | ) | const
| inlinefinaloverridevirtual

The deep copy method for a Node.

Implements Expression.

## ◆ isCompound()

bool isCompound | ( |  | ) | const
| inline

Query whether or not this is a compound AssignExpression. Compound AssignExpressions are assignments which read and write to the LHS value. i.e. +=, -=, *= etc.

Returns
  The binary operation as a tokens::OperatorToken

## ◆ isType()

template<typename NodeT >

bool isType | ( |  | ) | const
| inlineinherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## ◆ lhs()

const Expression * lhs | ( |  | ) | const
| inline

Access a const pointer to the AssignExpression LHS as an abstract expression.

Returns
  A const pointer to the LHS expression

## ◆ nodename()

const char * nodename | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.

## ◆ nodetype()

NodeType nodetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node type information.

Implements Node.

## ◆ operation()

tokens::OperatorToken operation | ( |  | ) | const
| inline

Query the actual operational type of this AssignExpression. For simple (non-compound) AssignExpressions, tokens::EQUALS is returned.

## ◆ parent()

const Node * parent | ( |  | ) | const
| inlineinherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## ◆ replace()

bool replace | ( | Node * | node | ) |
| inlineinherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## ◆ replacechild()

bool replacechild | ( | const size_t | i,
|  | Node * | node
| ) |  |
| inlinefinaloverridevirtual

Virtual method that attempted to replace a child at a given index with a provided node type.

Reimplemented from Node.

## ◆ rhs()

const Expression * rhs | ( |  | ) | const
| inline

Access a const pointer to the AssignExpression RHS as an.

abstract expression

Returns
  A const pointer to the RHS expression

## ◆ setParent()

void setParent | ( | Node * | parent | ) |
| inlineinherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## ◆ subname()

const char * subname | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.